#include <reg552.h>

#define ADCS 0x08
#define ADCI 0x10
#define ADEX 0x20

int ADC(unsigned char Channel)		//Rutina trva 55us pri 18.432MHz
{
 unsigned int x;
 ADCON=Channel;										//Vyber kanalu pre prevod 0..7
 ADCON|=(ADEX+ADCS);							//Spustim prevod, bolo tu ADCON|=ADEX+ADCS;
 while((ADCON&ADCI)==0x00);				//Cakam na ukoncenie prevodu
 ADCON^=ADCI;											//Nulujem priznak AD prevodnika
 x=ADCH*0x04;											//Normovanie na (int)
 switch(ADCON&(0x80+0x40))
  {
	 case	0x40	:	x+=0x01; break;
	 case	0x80	:	x+=0x02; break;
	 case	0xC0	:	x+=0x03; break;
	}
 return(x);
}