#ifdef DS87C550
#include <reg550.h>
#else
#include <reg552.h>
#endif

#define ADCS 0x08
#define ADCI 0x10
#define ADEX 0x20

/*
typedef union
{
 unsigned char adconv[2];
 int ADC_Result;
}
AD_Value;

int ADC(unsigned char Channel)		//Rutina trva 70us pri 18.432MHz
{
 xdata AD_Value x;
 //ADCON=Channel;										//Vyber kanalu pre prevod 0..7
 ADCON=ADEX+ADCS+Channel;						//Spustim prevod, bolo tu ADCON|=ADEX+ADCS;
 //while((ADCON&ADCI)==0x00);				//Cakam na ukoncenie prevodu
 while(!(ADCON&ADCI));						//Cakam na ukoncenie prevodu
 ADCON^=ADCI;											//Nulujem priznak AD prevodnika
 x.ADC_Result=ADCH*0x04;					//Normovanie na (int)
 switch(ADCON&(0x80|0x40))
  {
	 case	0x40	:	x.adconv[1]|=0x01; break;
	 case	0x80	:	x.adconv[1]|=0x02; break;
	 case	0xC0	:	x.adconv[1]|=0x03; break;
	}
 return(x.ADC_Result);
}
*/
/*
int ADC(unsigned char Channel)		//Rutina trva 51us pri 18.432MHz
{
 ADCON=ADEX+ADCS+Channel;					//Spustim prevod, bolo tu ADCON|=ADEX+ADCS;
 while(!(ADCON&ADCI));						//Cakam na ukoncenie prevodu
 ADCON^=ADCI;											//Nulujem priznak AD prevodnika
 switch(ADCON&(0x80|0x40))
  {
	 case	0x40	:	return(ADCH*0x04+0x01); break;
	 case	0x80	:	return(ADCH*0x04+0x02); break;
	 case	0xC0	:	return(ADCH*0x04+0x03); break;
	 default		:	return(ADCH*0x04); break;
	};
}
*/

int ADC(unsigned char Channel)		//Rutina trva 55us pri 18.432MHz
{
 int x;
 //ADCON=Channel;										//Vyber kanalu pre prevod 0..7
 ADCON=ADEX+ADCS+Channel;						//Spustim prevod, bolo tu ADCON|=ADEX+ADCS;
 //while((ADCON&ADCI)==0x00);				//Cakam na ukoncenie prevodu
 while(!(ADCON&ADCI));						//Cakam na ukoncenie prevodu
 ADCON^=ADCI;											//Nulujem priznak AD prevodnika
 x=ADCH*0x04;											//Normovanie na (int)
 switch(ADCON&(0x80|0x40))
  {
	 case	0x40	:	x+=0x01; break;
	 case	0x80	:	x+=0x02; break;
	 case	0xC0	:	x+=0x03; break;
	}
 return(x);
}
