;--------------------------------------------------------------------------------------
$NOMOD51
;--------------------------------------------------------------------------------------
public				_ADC_CONVERSION			;ADC_Conversion(unsigned char Channel)
public				CONVERSION				;Conversion(unsigned char Channel)
;--------------------------------------------------------------------------------------
Repeat				macro	Num
						anl a,#Num
						rl a
						rl a
					endm
;--------------------------------------------------------------------------------------
Result				macro
						Repeat MASKA		;LSB vysledku je v D7,D6 v ADCON[6..7]
						mov r7,a			;LSB AD prevodu 2 bitov R7=(ADCON[6..7]<<2) ...
						mov a,ADCH
						Repeat ~MASKA		;Ziskavam ADCH[0..5]<<2 & (~MASKA) a scitam ich s R7
						orl a,r7			;Scitavam ADCH[2..7] | R7
						xch a,r7			;vysledok ADCH[2..7] | (ADCON[6..7]<<2)
						mov a,ADCH			;A=ADCH
						Repeat MASKA		;Ziskavam ADCH[6..7]&MASKA
						mov r6,a			;Vysledok je MSB AD prevodu
					endm
;--------------------------------------------------------------------------------------
ADCON 				data 0C5h
ADCH  				data 0C6h
;--------------------------------------------------------------------------------------
ADCS				bit	acc.3				;Spustim prevod AD prevodnika
ADCI				bit	acc.4				;Kontrolujem ci je prevod ukonceny ADCON.4...
MASKA				equ	11000000B			;Maska equ 0xC0
;--------------------------------------------------------------------------------------
Prog_ADC_Converter	segment code
					rseg Prog_ADC_Converter
;--------------------------------------------------------------------------------------
_ADC_CONVERSION:	mov a,r7				;Vstupny parameter je cislo kanala pre meranie v R7
					setb ADCS				;Nastavim "ADC prevod"
					xch a,ADCON				;Obsah A potrebujem do ADCON aby sa AD prevod spustil
?PR?ADC_END:		mov a,ADCON				;ADCI signalizuje ukonceny prevod a pritomnost vysledku
					jnb ADCI,?PR?ADC_END	;Je prevod ukonceny ???
					clr ADCI				;bit ADCI nastavujem na 0
					mov ADCON,a
NO_INT:				Result
					ret
;--------------------------------------------------------------------------------------					
Prog_ADC_Conversion	segment code
					rseg Prog_ADC_Conversion
;--------------------------------------------------------------------------------------					
CONVERSION:			mov a,ADCON
NO_INTERRUPT:		Result
					ret
;--------------------------------------------------------------------------------------
;					cseg at 0053h			;os_attach_interrupt(10)
;					jmp CONVERSION
;					reti
;--------------------------------------------------------------------------------------
					end