//-------------------------------------------------------------------------------------------------------------------------------------------
enum {OFF=0, ON=1} Switches;
//-------------------------------------------------------------------------------------------------------------------------------------------
#define RegdTK			50												//Interval vzorkovania pre regulator dT=200ms, rozsah je od 15ms do 254ms
#define RegdTV			50												//Interval vzorkovania pre regulator dT=200ms, rozsah je od 15ms do 254ms
//-------------------------------------------------------------------------------------------------------------------------------------------
#define RegKKp			0.800
#define RegKTi			30.00
#define RegKTd			0.000
#define RegKSrvMin		0
#define RegKSrvZdvih	12
#define RegKSrvPosun	15
#define	RegKSrvMax		(RegKSrvZdvih*RegKSrvPosun)	//Natocenie o 180 za 180 sekund, Zdvih=12mm, Posun=15s/mm = 12*15=180s
#define RegKSrvHyster	2
#define RegKTkomfort	55							//Ziadana teplota
#define RegKTutlm 		RegKTkomfort-2				//Ziadana teplota
#define RegKTdT			(RegKTkomfort-RegKTutlm)
#define RegKTmin		0							//Minimalna teplota media
#define RegKTmax		90							//Maximalna teplota media
#define RegKTlimit		13							//Od akej teploty mam zacat kurit ...
#define RegKKrivka		10							//Ekvitermicka krivka ...
//-------------------------------------------------------------------------------------------------------------------------------------------
#define RegVKp			0.800
#define RegVTi			35.00
#define RegVTd			0.000
#define RegVSrvMin		0
#define RegVSrvZdvih	12
#define RegVSrvPosun	3
#define	RegVSrvMax		(RegVSrvZdvih*RegVSrvPosun)	//Natocenie o 180 za 36 sekund, Zdvih=12mm, Posun=3s/mm = 12*3=36s
#define RegVSrvHyster	2
#define RegVTkomfort	55
#define RegVTutlm 		RegVTkomfort-5
#define RegVTdT			(RegVTkomfort-RegVTutlm)
#define RegVTmin		0
#define RegVTmax		50
#define RegVTlimit		13
#define RegVKrivka		10
//-------------------------------------------------------------------------------------------------------------------------------------------

code	Parameter						FactoryK = 
										 {
										  'Y',																																																																	//Reset
											0,0,0,																																																																//SetPosition,ActualPosition,dPosition
											0,0,0,																																																																//E0,E1,E2,											
											RegKSrvMin,RegKSrvMax,RegKSrvHyster,																																																	//Servo_Min,Servo_Max,Hysterezia
											RegKTkomfort,RegKTutlm,RegKTdT,RegKTmin,RegKTmax,RegKTlimit,																																					//Tkomfort,Tutlm,deltaT,Tmin,Tmax,Tlimit
											RegdTK,
											RegKKp,RegKTi,RegKTd,(RegKKp*(1.0+(RegdTK*0.01)/(2.0*RegKTi))),(RegKKp*(1.0-(RegdTK*0.01)/(2.0*RegKTi))),(RegKKp*(RegKTd/(RegdTK*0.01))),0.000,0.000,		//dT,Kp,Ti,Td,KA,KB,KC,Y0,Y1
											ON,ON,RegKKrivka,																																																											//Comfort,Pump,Vykurovacia_Krivka
											{{4,30},{4,30},{4,30},{4,30},{4,30},{5,30},{5,30}},																																										//Intervaly od do
											{{22,00},{22,00},{22,00},{22,00},{22,00},{22,00},{22,00}}																																							//Intervaly od do
										 },
										FactoryV = 
										 {
										  'Y',
											0,0,0,
											0,0,0,
											RegVSrvMin,RegVSrvMax,RegVSrvHyster,
											RegVTkomfort,RegVTutlm,RegVTdT,RegVTmin,RegVTmax,RegVTlimit,
											RegdTV,
											RegVKp,RegVTi,RegVTd,(RegVKp*(1.0+(RegdTV*0.01)/(2.0*RegVTi))),(RegVKp*(1.0-(RegdTV*0.01)/(2.0*RegVTi))),(RegVKp*(RegVTd/(RegdTV*0.01))),0.000,0.000,
											ON,ON,RegVKrivka,
											{{3,30},{3,30},{3,30},{3,30},{3,30},{5,30},{5,30}},
											{{22,00},{22,00},{22,00},{22,00},{22,00},{22,00},{22,00}}
										 };