/*----------------------------------------------------------------------
 *      BEGIN OF HEADER FILE
 *----------------------------------------------------------------------*/

/*
 *  This file contains the data defintions that are stored in EEPROM by Eduard Jadron
 */


#pragma SAVE
#pragma REGPARMS

#define	high(number) ((char)((number & 0xFF00)>>8))
#define	low(number) ((char)(number & 0x00FF))

#define xtal(number) ((long int)(number/1200))


#pragma RESTORE

enum Riadky {Riadok1=0x00,Riadok2=0x40,Riadok3=0x14,Riadok4=0x54};
enum Line		{Line1=0x00,Line2=0x01,Line3=0x02,Line4=0x03};

typedef struct _lcd_screen
{
 unsigned char lcd_line[4][LCD_Size+2];
}
lcd_screen;

/*----------------------------------------------------------------------
 *      END OF HEADER FILE
 *----------------------------------------------------------------------*/

